########################################################################
# $Header: /var/local/cvsroot/4Suite/Ft/Xml/MessageSource.py,v 1.11 2005/09/13 00:14:15 jkloth Exp $
"""
Localizable message strings

Copyright 2005 Fourthought, Inc. (USA).
Detailed license and copyright information: http://4suite.org/COPYRIGHT
Project home, documentation, distributions: http://4suite.org/
"""

from Ft import TranslateMessage as _
from Ft.Xml import ReaderException, XIncludeException

XINCLUDE = {
    XIncludeException.MISSING_HREF : _('Missing or empty href attribute'),
    XIncludeException.INVALID_PARSE_ATTR : _(
    'Invalid value %r for parse attribute'),
    XIncludeException.TEXT_XPOINTER : _(
    'xpointer attribute forbidden for parse="text"'),
    XIncludeException.FRAGMENT_IDENTIFIER : _(
    'Fragment identifier not allowed in URI %r; use the xpointer attribute'),
    XIncludeException.UNSUPPORTED_XPOINTER : _(
    'Unsupported XPointer %r'),
    XIncludeException.INCLUDE_IN_INCLUDE :_(
    'xi:include has an xi:include child'),
    XIncludeException.FALLBACK_NOT_IN_INCLUDE : _(
    'xi:fallback is not the child of an xi:include'),
    XIncludeException.MULTIPLE_FALLBACKS : _(
    'xi:include with multiple xi:fallback children'),
    }

READER = {
    ReaderException.XML_PARSE_ERROR: _('XML parse error in %r at line %d, column %d: %s'),
    ReaderException.RECURSIVE_PARSE_ERROR: _('Recursive parsing of %r'),
    ReaderException.XMLNS_UNKNOWN_PREFIX: _('Unknown namespace prefix found while parsing XML file: %s'),
    ReaderException.XMLNS_DUPLICATE_ATTRS: _('Element %r has duplicate attributes: %r and %r'),
    ReaderException.INVALID_XMLNS: _('Invalid xmlns found parsing XML file: %s'),
    }

